import java.io.IOException;
import java.util.Scanner;
import type.lib.ToolBox;

public class Labtest12_Sec03_Part1 {

	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) {

		/**
		 * GOAL: write a program that prompts the user for a particular type of
		 * input, parses that input and gives specific error messages.
		 */

		/**
		 * [1 mark] Step 1: Read the string that the user enters in response to
		 * the provided prompt. Store it in an appropriately named variable.
		 */
		String PROMPT = "Enter a string of the form h:m:ind,\n"
				+ "where h is the hour (0<h<=12),\n"
				+ "m is the minute (0<=m<=59),\n"
				+ "ind is the period indicator (am or pm, case insensitive): ";

		/**
		 * [2 marks] Step 2: Parse the user input to string values for the "h",
		 * "m", and "ind" components. Use the colon as the basis for parsing
		 * using the indexOf/substring methods as in fig 11.4. (There are
		 * several other methods for doing this). For this step, you can assume
		 * the user input is well formed. Hint: to find the index of the second
		 * colon, have a look at the method with the signature indexOf(String,
		 * int). Print out each of the three string values to System.out
		 */

		/**
		 * [2 marks] Step 3: Add a try-catch block around the code from step 2
		 * above so that if the user neglects to include the two colons so that
		 * the string cannot be parsed into the three components, the message
		 * "Missing colon!" is printed and the app finishes (without crashing).
		 */

		/**
		 * [3 marks] Step 4: Add to the code developed in Step 3. Parse each of
		 * the h and m components as ints. Print out the ints to the System.out.
		 * Add an additional catch block to deal with the case in which the user
		 * does not enter a string that can be parsed as an int. In such cases,
		 * the message "Non-numeric data!" should be printed and the app
		 * finishes (without crashing).
		 */

		/**
		 * [3 marks] Step 5: Add to the code developed in Step 4. Within the try
		 * block, add an if clause to test whether the h and m component fall
		 * within the specified range of allowable ints. If either do not, use a
		 * technique for throwing an exception as described in Example 11.3. The
		 * file type.jar has been included in this project so that you may use
		 * the services of ToolBox, if you desire. In such cases, the message
		 * "Values out of range!" should be printed and the app finishes
		 * (without crashing).
		 */

		/**
		 * [2 marks] Step 6, Bonus: Add to the code developed in Step 5. Modify
		 * the code so that the user is reprompted if he or she enters a string
		 * that causes an exception to be thrown.
		 */

	}
}
