package soln;
import java.io.IOException;
import java.util.Scanner;
import type.lib.ToolBox;

public class Labtest12_Sec01_Part1 {

	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) {

		/**
		 * GOAL: write a program that prompts the user for a particular type of
		 * input, parses that input and gives specific error messages.
		 */

		/**
		 * [1 mark] Step 1: Read the string that the user enters in response to
		 * the provided prompt. Store it in an appropriately named variable.
		 */
		String PROMPT = "Enter a string of the form h:m:ind,\n"
				+ "where h is the hour (0<h<=12),\n"
				+ "m is the minute (0<=m<=59),\n"
				+ "ind is the period indicator (am or pm, case insensitive): ";
//		System.out.println(PROMPT);
//		Scanner input = new Scanner(System.in);
//		String userInput = input.nextLine();

		/**
		 * [2 marks] Step 2: Parse the user input to string values for the "h",
		 * "m", and "ind" components. Use the colon as the basis for parsing
		 * using the indexOf/substring methods as in fig 11.4. (There are
		 * several other methods for doing this). For this step, you can assume
		 * the user input is well formed. Hint: to find the index of the second
		 * colon, have a look at the method with the signature indexOf(String,
		 * int). Print out each of the three string values to System.out
		 */
		// int colon1Idx = userInput.indexOf(":");
		// int colon2Idx = userInput.indexOf(":", colon1Idx + 1);
		// System.out.println(colon1Idx + " " + colon2Idx);
		// String hComponent = userInput.substring(0, colon1Idx);
		// String mComponent = userInput.substring(colon1Idx + 1, colon2Idx);
		// String indComponent = userInput.substring(colon2Idx + 1);
		// System.out.println(hComponent + " " + mComponent + " " +
		// indComponent);
		/**
		 * [2 marks] Step 3: Add a try-catch block around the code from step 2
		 * above so that if the user neglects to include the two colons so that
		 * the string cannot be parsed into the three components, the message
		 * "Missing colon!" is printed and the app finishes (without crashing).
		 */

		// try {
		// int colon1Idx = userInput.indexOf(":");
		// int colon2Idx = userInput.indexOf(":", colon1Idx + 1);
		// // System.out.println(colon1Idx + " " + colon2Idx);
		// String hComponent = userInput.substring(0, colon1Idx);
		// String mComponent = userInput.substring(colon1Idx + 1, colon2Idx);
		// String indComponent = userInput.substring(colon2Idx + 1);
		// System.out.println(hComponent + " " + mComponent + " "
		// + indComponent);
		// } catch (IndexOutOfBoundsException e) {
		// System.out.println("Missing colon!");
		// }

		/**
		 * [3 marks] Step 4: Add to the code developed in Step 3. Parse each of
		 * the h and m components as ints. Print out the ints to the System.out.
		 * Add an additional catch block to deal with the case in which the user
		 * does not enter a string that can be parsed as an int. In such cases,
		 * the message "Non-numeric data!" should be printed and the app
		 * finishes (without crashing).
		 */

		// try {
		// int colon1Idx = userInput.indexOf(":");
		// int colon2Idx = userInput.indexOf(":", colon1Idx + 1);
		// // System.out.println(colon1Idx + " " + colon2Idx);
		// String hComponent = userInput.substring(0, colon1Idx);
		// String mComponent = userInput.substring(colon1Idx + 1, colon2Idx);
		// String indComponent = userInput.substring(colon2Idx + 1);
		// System.out.println(hComponent + " " + mComponent + " "
		// + indComponent);
		// int hValue = Integer.parseInt(hComponent);
		// int mValue = Integer.parseInt(mComponent);
		// System.out.println(hValue + " " + mValue);
		// } catch (IndexOutOfBoundsException e) {
		// System.out.println("Missing colon!");
		// } catch (NumberFormatException e) {
		// System.out.println("Non-numeric data!");
		// }

		/**
		 * [3 marks] Step 5: Add to the code developed in Step 4. Within the try
		 * block, add an if clause to test whether the h and m component fall
		 * within the specified range of allowable ints. If either do not, use a
		 * technique for throwing an exception as described in Example 11.3. The
		 * file type.jar has been included in this project so that you may use
		 * the services of ToolBox, if you desire. In such cases, the message
		 * "Values out of range!" should be printed and the app finishes
		 * (without crashing).
		 */

		// try {
		// int colon1Idx = userInput.indexOf(":");
		// int colon2Idx = userInput.indexOf(":", colon1Idx + 1);
		// // System.out.println(colon1Idx + " " + colon2Idx);
		// String hComponent = userInput.substring(0, colon1Idx);
		// String mComponent = userInput.substring(colon1Idx + 1, colon2Idx);
		// String indComponent = userInput.substring(colon2Idx + 1);
		// System.out.println(hComponent + " " + mComponent + " "
		// + indComponent);
		// int hValue = Integer.parseInt(hComponent);
		// int mValue = Integer.parseInt(mComponent);
		// System.out.println(hValue + " " + mValue);
		// boolean test1 = hValue <= 0 || hValue > 12;
		// boolean test2 = mValue < 0 || mValue > 59;
		// // Approach #1
		// // if (test1 || test2) {
		// // throw new UnsupportedOperationException("Values out of range!");
		// // }
		// // or Approach #2
		// ToolBox.crash(test1 || test2, "Values out of range!");
		// } catch (IndexOutOfBoundsException e) {
		// System.out.println("Missing colon!");
		// } catch (NumberFormatException e) {
		// System.out.println("Non-numeric data!");
		// // Approach #1
		// // } catch (UnsupportedOperationException e) {
		// // System.out.println(e.getMessage());
		// // Approach #2
		// } catch (RuntimeException e) {
		// System.out.println(e.getMessage());
		// }

		/**
		 * [2 marks] Step 6, Bonus: Add to the code developed in Step 5. Modify
		 * the code so that the user is reprompted if he or she enters a string
		 * that causes an exception to be thrown.
		 */
		boolean shouldReprompt = true;
		while (shouldReprompt) {
			System.out.println(PROMPT);
			Scanner input = new Scanner(System.in);
			String userInput = input.nextLine();

			try {
				int colon1Idx = userInput.indexOf(":");
				int colon2Idx = userInput.indexOf(":", colon1Idx + 1);
				// System.out.println(colon1Idx + " " + colon2Idx);
				String hComponent = userInput.substring(0, colon1Idx);
				String mComponent = userInput.substring(colon1Idx + 1,
						colon2Idx);
				String indComponent = userInput.substring(colon2Idx + 1);
				System.out.println(hComponent + " " + mComponent + " "
						+ indComponent);
				int hValue = Integer.parseInt(hComponent);
				int mValue = Integer.parseInt(mComponent);
				System.out.println(hValue + " " + mValue);
				boolean test1 = hValue <= 0 || hValue > 12;
				boolean test2 = mValue < 0 || mValue > 59;
				shouldReprompt = false;
				// Approach #1
				// if (test1 || test2) {
				// throw new
				// UnsupportedOperationException("Values out of range!");
				// }
				// or Approach #2
				ToolBox.crash(test1 || test2, "Values out of range!");
			} catch (IndexOutOfBoundsException e) {
				System.out.println("Missing colon!");
			} catch (NumberFormatException e) {
				System.out.println("Non-numeric data!");
				// Approach #1
				// } catch (UnsupportedOperationException e) {
				// System.out.println(e.getMessage());
				// Approach #2
			} catch (RuntimeException e) {
				System.out.println(e.getMessage());
			}
		}

	}
}
